// (c) J. Dean Brock, Rebecca F. Bruce, 2001, 2004
// Department of Computer Science
// University of North Carolina at Asheville

package edu.unca.cs.csci201.LabAids;

import java.io.* ;
import java.util.Random ;
import edu.unca.cs.csci201.LabAids.SpecArrayOp ;

/** The test driver for the ArrayOp lab.  The class contains a single static method. */
public class TestArrayOp {

  // These values restrict the size of the arrays
  // created to test the array functions.
  private static final int ArrayMinSize =  7 ;
  private static final int ArrayMaxSize = 11 ;
  // These values restrict the elements generated
  // for the arrays used to test the array functions.
  private static final int ElementMinValue = 100 ;
  private static final int ElementMaxValue = 999 ;

  /** A static method that tests the array operation.  An array of random size and
   * values is generated and passed to the TestFunc method of an object satisfying the
   * SpecArrayOp interface.  The contents of the array is printed along with the
   * value returned by TestFunc.
   * @param testObj The class to be tested.
   */  
  public static void TestArrayOperation(SpecArrayOp testObj)
  {
    Random R = new Random() ;
    int ArraySize = Math.abs(R.nextInt())%(ArrayMaxSize-ArrayMinSize) + ArrayMinSize ;
    int testVect[] = new int[ArraySize] ;
    for (int i=0; i<ArraySize; ++i)
      testVect[i] = Math.abs(R.nextInt())%(ElementMaxValue-ElementMinValue) + ElementMinValue ;
    int TestRes = testObj.TestFunc(testVect) ;
    System.out.println("Testing " + testObj.getClass().getName()) ;
    System.out.print("  ") ;
    if (ArraySize>0)
      System.out.print(testVect[0]) ;
    for (int i=1; i<ArraySize; ++i)
      System.out.print(", " + testVect[i]) ;
    System.out.println(" -> " + TestRes) ;
    System.out.println() ;
  }
}
